package com.android.sample.tvusdkdemo;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.tvunetworks.android.sdk.TVUAnywhereSDK;

public class RegisterActivity extends Activity {
    private static final String TAG = RegisterActivity.class.getSimpleName();

    public static final String KEY_APP_KEY = "APP_KEY";
    public static final String KEY_APP_SECRET = "APP_SECRET";
    public static final String KEY_USER_NAME = "USER_NAME";
    public static final String KEY_USER_PASSWORD = "USER_PASSWORD";

    public static final String KEY_REGISTER_PREFERENCES = "REGISTER_PREFERENCES";
    public static final String KEY_RECEIVER_ID = "RECEIVER_ID";
    public static final String KEY_RD_RECEIVER_ID = "";

    public static final String KEY_RTMP_URL = "RTMP_URL";

    private static final String KEY_RD_APP_KEY = "";
    private static final String KEY_RD_APP_SECRET = "";
    private static final String KEY_RD_USER_NAME = "";
    private static final String KEY_RD_USER_PASSWORD = "";

    private EditText etAppKey, etAppSecret, etEmail, etPassword;
    private Button btnRegister;

    private SharedPreferences preferences;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_register);
        getActionBar().setDisplayShowHomeEnabled(false);

        preferences = getSharedPreferences(KEY_REGISTER_PREFERENCES, Context.MODE_PRIVATE);

        etAppKey = (EditText) findViewById(R.id.et_appkey);
        etAppSecret = (EditText) findViewById(R.id.et_secret);
        etEmail = (EditText) findViewById(R.id.et_name);
        etPassword = (EditText) findViewById(R.id.et_password);
        btnRegister = (Button) findViewById(R.id.btn_register);

        etAppKey.setText(preferences.getString(KEY_APP_KEY, KEY_RD_APP_KEY));
        etAppSecret.setText(preferences.getString(KEY_APP_SECRET, KEY_RD_APP_SECRET));
        etEmail.setText(preferences.getString(KEY_USER_NAME, KEY_RD_USER_NAME));
        etPassword.setText(preferences.getString(KEY_USER_PASSWORD, KEY_RD_USER_PASSWORD));

        btnRegister.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                doRegister();
                RegisterActivity.this.finish();
            }
        });
    }

    @Override
    protected void onPause() {
        super.onPause();
        doRegister();
    }

    private void doRegister() {
        final Editable appkey = etAppKey.getText();
        final Editable secret = etAppSecret.getText();
        final Editable email = etEmail.getText();
        final Editable password = etPassword.getText();

        if (TextUtils.isEmpty(appkey) || TextUtils.isEmpty(secret) || TextUtils.isEmpty(email) || TextUtils.isEmpty(password)) {
            Toast.makeText(RegisterActivity.this, "Please fill in the blank item", Toast.LENGTH_LONG).show();
            return;
        }

        final String keyStr = appkey.toString().trim();
        final String secretStr = secret.toString().trim();
        final String emailStr = email.toString().trim();
        final String passwordStr = password.toString().trim();

        if (TextUtils.isEmpty(keyStr) || TextUtils.isEmpty(secretStr) || TextUtils.isEmpty(emailStr) || TextUtils.isEmpty(passwordStr)) {
            Toast.makeText(RegisterActivity.this, "Please input the legal info", Toast.LENGTH_LONG).show();
            return;
        }

        preferences.edit()
                .putString(KEY_APP_KEY, keyStr)
                .putString(KEY_APP_SECRET, secretStr)
                .putString(KEY_USER_NAME, emailStr)
                .putString(KEY_USER_PASSWORD, passwordStr)
                .apply();

        TVUAnywhereSDK.getInstance().registerTVUAnywhereSDKWithAppKey(keyStr,
                secretStr,
                emailStr,
                passwordStr);
    }
}
